unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, SQLDB, SQLite3Conn, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, DBCtrls, DBGrids, StdCtrls, sqlite3dyn;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    dsOut: TDataSource;
    Edit1: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    sqlCon1: TSQLite3Connection;
    qOut: TSQLQuery;
    qInsertIntoTable: TSQLQuery;
    qCreateTable: TSQLQuery;
    sqlTran1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;


implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  ThisMoment : TDateTime;
begin
   {$IFDEF UNIX}
        {$IFNDEF DARWIN}
          sqlite3dyn.SQLiteDefaultLibrary := './libsqlite3.so.0.8.6';
        {$ENDIF}
   {$ENDIF}

  {$IFDEF WINDOWS} // Windows
     sqlite3dyn.SQLiteDefaultLibrary := 'sqlite3.dll';
  {$ENDIF}


  ThisMoment := Now;
  sqlCon1.DatabaseName := FormatDateTime('YYYYMMDD_hhnnss',ThisMoment)+'_test.sqlite';

  try
    sqlCon1.Open;
    sqlTran1.Active := true;
  except
     ShowMessage('It is impossible to create a database file');
     exit;
   end;

  try
    qCreateTable.ExecSQL;

   // qInsertIntoTable.UniDirectional:=True;
    qInsertIntoTable.Params.ParamByName('QtyRows').AsInteger := strtoint(Edit1.Text);
    qInsertIntoTable.ExecSQL;
    sqlTran1.Commit;

    ShowMessage('The table is created, check the possibility of going to the last rows (TSQLQuery.Last, use DBNavigator)');
    qOut.Open;
   except
     ShowMessage('Unable to create a table');
     exit;
   end;
 end;

end.

